-- merge.lua
-- Written By Habna


function Merge()
	write( "HugeBag: Merging started" );
	
	for DestSlot = 1, backpackSize do
		TargetItem = frmMain.backpack:GetItem(DestSlot);
		TargetName = "zEmpty";
		--Get the name of the destination item
		if TargetItem ~= nil then TargetName = TargetItem:GetName(); end
		
		for SourceSlot = DestSlot + 1, backpackSize do
			SourceItem = frmMain.backpack:GetItem(SourceSlot);
			SourceName = "zEmpty";
			--Get the name of the source item
			if SourceItem ~= nil then
				SourceName = SourceItem:GetName();
				ItemMaxStackSize = SourceItem:GetMaxStackSize();
				ItemQuantity = SourceItem:GetQuantity();
			end
			
			if SourceName == TargetName and SourceName ~= "zEmpty" then
				if ItemMaxStackSize ~= 1 and ItemQuantity < ItemMaxStackSize then swap( DestSlot, SourceSlot ); end
			end
		end
	end
	
	SortButton:SetVisible( true );
	SearchButton:SetVisible( true );
	MergeButton:SetVisible( true );
	write( "HugeBag: Merging finished" );
end

function swap( i, j )
	
	if frmMain.backpack:GetItem( j ) == frmMain.backpack:GetItem( i ) then return end
	item = frmMain.backpack:GetItem( j );

	if item ~= nil then
		frmMain.backpack:PerformItemDrop( item, i, false );
		return
	end
	
	write( "Should never be seen. Error in Swap function." );
end